function init()
	-- RAINBOOM VARIABLES
	self.airDashing = false
	self.dashing = false
	self.dashTimer = 0
	self.dashDirection = 0
	self.dashLastInput = 0
	self.dashTapLast = 0
	self.dashTapTimer = 0
	-- FLIGHT VARIABLES
	self.lastJump = false
	self.lastBoost = nil
	-- CUSTOM VARIABLES
	self.isFlying = false
	self.isRainboom = false
	-- DASH ACTION REPLACER
	self.rainboomAction = nil
end

function input(args)
	-- VISUAL DEBUGING HELP
	--debughelp()
	
	-- FLIGHT VARIABLES
	local currentJump = args.moves["jump"]
	local currentBoost = nil

	-- RAINBOOM TIMER
	if self.dashTimer > 0 then
	--	return nil
	end
	
	-- RAINBOOM ACTION REPLACER TO NIL
	self.rainboomAction = nil

	-- RAINBOOM VARIABLES
	local maximumDoubleTapTime = tech.parameter("maximumDoubleTapTime")

	-- RAINBOOM DOUBLE TAP TIMER
	if self.dashTapTimer > 0 then
		self.dashTapTimer = self.dashTapTimer - args.dt
	end
	
	--RAINBOOM INPUT SCRIPT
	if args.moves["right"] then
		if self.dashLastInput ~= 1 then
			if self.dashTapLast == 1 and self.dashTapTimer > 0 then
				self.dashTapLast = 0
				self.dashTapTimer = 0
				self.rainboomAction = "dashRight"
			else
				self.dashTapLast = 1
				self.dashTapTimer = maximumDoubleTapTime
			end
		end
		if self.rainboomAction == nil then
			self.dashLastInput = 1
		end
	elseif args.moves["left"] then
		if self.dashLastInput ~= -1 then
			if self.dashTapLast == -1 and self.dashTapTimer > 0 then
				self.dashTapLast = 0
				self.dashTapTimer = 0
				self.rainboomAction = "dashLeft"
			else
				self.dashTapLast = -1
				self.dashTapTimer = maximumDoubleTapTime
			end
		end
		if self.rainboomAction == nil then
			self.dashLastInput = -1
		end
	else
		self.dashLastInput = 0
	end
	
	-- FLIGHT INPUT SCRIPT
	if not mcontroller.onGround() then
		if not mcontroller.canJump() and currentJump and not self.lastJump then
			if args.moves["right"] and args.moves["up"] then
				currentBoost = "boostRightUp"
			elseif args.moves["right"] and args.moves["down"] then
				currentBoost = "boostRightDown"
			elseif args.moves["left"] and args.moves["up"] then
				currentBoost = "boostLeftUp"
			elseif args.moves["left"] and args.moves["down"] then
				currentBoost = "boostLeftDown"
			elseif args.moves["right"] then
				currentBoost = "boostRight"
			elseif args.moves["down"] then
				currentBoost = "boostDown"
			elseif args.moves["left"] then
				currentBoost = "boostLeft"
			elseif args.moves["up"] then
				currentBoost = "boostUp"
			end
		elseif currentJump and self.lastBoost then
			currentBoost = self.lastBoost
		end
	end

	if self.isFlying and not mcontroller.onGround() then
		if args.moves["right"] and args.moves["up"] then
			currentBoost = "boostRightUp"
		elseif args.moves["right"] and args.moves["down"] then
			currentBoost = "boostRightDown"
		elseif args.moves["left"] and args.moves["up"] then
			currentBoost = "boostLeftUp"
		elseif args.moves["left"] and args.moves["down"] then
			currentBoost = "boostLeftDown"
		elseif args.moves["right"] then
			currentBoost = "boostRight"
		elseif args.moves["down"] then
			currentBoost = "boostDown"
		elseif args.moves["left"] then
			currentBoost = "boostLeft"
		elseif args.moves["up"] then
			currentBoost = "boostUp"
		end
	end
	self.lastJump = currentJump
	self.lastBoost = currentBoost
	
	debughelp()
	
	return currentBoost
end

function update(args)
	--FLIGHT VARIABLES
	local boostControlForce = tech.parameter("boostControlForce")
	local boostSpeed = tech.parameter("boostSpeed")
	local energyUsagePerSecond = tech.parameter("energyUsagePerSecond")
	local diag = 1 / math.sqrt(2)
	local boostDirection = false
	
	--RAINBOOM VARIABLES
	local dashControlForce = tech.parameter("dashControlForce")
	local dashSpeed = tech.parameter("dashSpeed")
	local dashDuration = tech.parameter("dashDuration")
	local groundOnly = tech.parameter("groundOnly")
	local groundValid = not groundOnly or mcontroller.onGround()
	
	-- RAINBOOM SCRIPT
	if self.rainboomAction == "dashRight" and groundValid and self.dashTimer <= 0 and tech.consumeTechEnergy(tech.parameter("energyUsage")) then
		self.dashTimer = dashDuration
		self.dashDirection = 1
		self.airDashing = not mcontroller.onGround()
	elseif self.rainboomAction == "dashLeft" and groundValid and self.dashTimer <= 0 and tech.consumeTechEnergy(tech.parameter("energyUsage")) then
		self.dashTimer = dashDuration
		self.dashDirection = -1
		self.airDashing = not mcontroller.onGround()
	end

	if self.dashTimer > 0 then
		mcontroller.controlApproachXVelocity(dashSpeed * self.dashDirection, dashControlForce, true)
		self.dashing = true

		if self.airDashing then
			mcontroller.controlParameters({gravityEnabled = false})
			mcontroller.controlApproachYVelocity(0, dashControlForce, true)
		end

		if self.dashDirection == -1 then
			mcontroller.controlFace(-1)
			tech.setFlipped(true)
		else
			mcontroller.controlFace(1)
			tech.setFlipped(false)
		end
		--RAINBOOM ANIMATION ON
		tech.setAnimationState("dashing", "on")
		tech.setParticleEmitterActive("dashParticles", true)
		tech.setParticleEmitterActive("dashParticles2", true)
		self.dashTimer = self.dashTimer - args.dt
		self.isRainboom = true
	else
		--RAINBOOM ANIMATION OFF
		tech.setAnimationState("dashing", "off")
		tech.setParticleEmitterActive("dashParticles", false)
		tech.setParticleEmitterActive("dashParticles2", false)
		
		--
		if self.dashing and tech.parameter("stopAfterDash") then
			local movementParams = mcontroller.baseParameters()
			mcontroller.controlApproachXVelocity(self.dashDirection * movementParams.runSpeed, dashControlForce)
		end
		self.dashing = false
		self.isRainboom = false
	end
	-- FLIGHT SCRIPT

	if args.actions["boostRightUp"] then
		boostDirection = {boostSpeed * diag, boostSpeed * diag}
	elseif args.actions["boostRightDown"] then
		boostDirection = {boostSpeed * diag, -boostSpeed * diag}
	elseif args.actions["boostLeftUp"] then
		boostDirection = {-boostSpeed * diag, boostSpeed * diag}
	elseif args.actions["boostLeftDown"] then
		boostDirection = {-boostSpeed * diag, -boostSpeed * diag}
	elseif args.actions["boostRight"] then
		boostDirection = {boostSpeed, 0}
	elseif args.actions["boostDown"] then
		boostDirection = {0, -boostSpeed}
	elseif args.actions["boostLeft"] then
		boostDirection = {-boostSpeed, 0}
	elseif args.actions["boostUp"] then
		boostDirection = {0, boostSpeed}
	end
	
	if boostDirection and tech.consumeTechEnergy(energyUsagePerSecond * args.dt) then
		if self.isRainboom then
			mcontroller.controlApproachVelocity({boostDirection[1] * 100, boostDirection[2]}, boostControlForce, true, true)
		else
			mcontroller.controlApproachVelocity(boostDirection, boostControlForce, true, true)
		end
		self.isFlying = true
	else
		self.isFlying = false
	end
	
end

function debughelp(x)
	if self.isFlying  then
		world.debugText("flying",{mcontroller.position()[1]-1,mcontroller.position()[2]-3.5}, "green")
	else
		world.debugText("not flying",{mcontroller.position()[1]-1.5,mcontroller.position()[2]-3.5}, "red")
	end
	
	if self.isRainboom  then
		world.debugText("rainboom",{mcontroller.position()[1]-1.8,mcontroller.position()[2]+1.5}, "green")
	else
		world.debugText("no rainboom",{mcontroller.position()[1]-2,mcontroller.position()[2]+1.5}, "red")
	end
end